<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1application_utilities.html">applicationUtilities</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1application_utilities_1_1android_utilities.html">androidUtilities</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html">AndroidSLESEngine</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_android_s_l_e_s_engine_8h_source.html">AndroidSLESEngine.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine_inherit__map" id="alexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine_inherit__map">
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine_coll__map" id="alexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine_coll__map">
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a5f73a34cd83d0db28834d268625c4dee"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_microphone.html">AndroidSLESMicrophone</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html#a5f73a34cd83d0db28834d268625c4dee">createMicrophoneRecorder</a> (std::shared_ptr&lt; <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a0e5ba82a4fcf54f83464cb9a9d944e91">avsCommon::avs::AudioInputStream</a> &gt; stream)</td></tr>
<tr class="separator:a5f73a34cd83d0db28834d268625c4dee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21ba1f5b111e8227cf69f3625887f706"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html#a21ba1f5b111e8227cf69f3625887f706">createPlayer</a> (SLDataSource &amp;source, SLDataSink &amp;sink, bool requireEqualizer) const</td></tr>
<tr class="separator:a21ba1f5b111e8227cf69f3625887f706"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b34ed222db2ee15b11b201d69035020"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html#a5b34ed222db2ee15b11b201d69035020">createOutputMix</a> () const</td></tr>
<tr class="separator:a5b34ed222db2ee15b11b201d69035020"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8669a7b5741ee64110c1d8d4a2ce5114"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html#a8669a7b5741ee64110c1d8d4a2ce5114">~AndroidSLESEngine</a> ()</td></tr>
<tr class="separator:a8669a7b5741ee64110c1d8d4a2ce5114"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ac10c5e2ad660c9e4edb0ee07645e22b9"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html">AndroidSLESEngine</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html#ac10c5e2ad660c9e4edb0ee07645e22b9">create</a> ()</td></tr>
<tr class="separator:ac10c5e2ad660c9e4edb0ee07645e22b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Class that represents the OpenSL ES engine object + interfaces.</p>
<p class="">The engine is used to create other OpenSL ES objects, and each application should only have one engine. Furthermore, the engine should be the first OpenSL ES object to be created and the last to be destroyed.</p>
<p class="">The <code>create</code> method ensures that the application has only one engine. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a8669a7b5741ee64110c1d8d4a2ce5114"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8669a7b5741ee64110c1d8d4a2ce5114">&#9670;&nbsp;</a></span>~AndroidSLESEngine()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine::~AndroidSLESEngine </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ac10c5e2ad660c9e4edb0ee07645e22b9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac10c5e2ad660c9e4edb0ee07645e22b9">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html">AndroidSLESEngine</a> &gt; alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine::create </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates an <code><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html">AndroidSLESEngine</a></code>. This method will only succeed if there is no other engine alive.</p>
<dl class="section return"><dt>Returns</dt><dd>A shared pointer to an <code><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_engine.html">AndroidSLESEngine</a></code> object if succeeds; otherwise return <code>nullptr</code>. </dd></dl>

</div>
</div>
<a id="a5f73a34cd83d0db28834d268625c4dee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5f73a34cd83d0db28834d268625c4dee">&#9670;&nbsp;</a></span>createMicrophoneRecorder()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_microphone.html">AndroidSLESMicrophone</a> &gt; alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine::createMicrophoneRecorder </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a0e5ba82a4fcf54f83464cb9a9d944e91">avsCommon::avs::AudioInputStream</a> &gt;&#160;</td>
          <td class="paramname"><em>stream</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Creates an OpenSL ES audio recorder.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">stream</td><td>The new microphone will write the audio recorded to this stream. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A unique pointer to an <code>AndroidSLESRecorder</code> object if succeeds; otherwise return <code>nullptr</code>. </dd></dl>

</div>
</div>
<a id="a5b34ed222db2ee15b11b201d69035020"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5b34ed222db2ee15b11b201d69035020">&#9670;&nbsp;</a></span>createOutputMix()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a> &gt; alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine::createOutputMix </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Creates an OpenSL ES output mix.</p>
<dl class="section return"><dt>Returns</dt><dd>A unique pointer to an <code><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a></code> object if succeeds; otherwise return <code>nullptr</code>. </dd></dl>

</div>
</div>
<a id="a21ba1f5b111e8227cf69f3625887f706"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a21ba1f5b111e8227cf69f3625887f706">&#9670;&nbsp;</a></span>createPlayer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a> &gt; alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESEngine::createPlayer </td>
          <td>(</td>
          <td class="paramtype">SLDataSource &amp;&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SLDataSink &amp;&#160;</td>
          <td class="paramname"><em>sink</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>requireEqualizer</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Creates an OpenSL ES audio player. Although the parameters are read-only, we cannot use const because android's API expects non-constant parameters.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">source</td><td>The audio data source specification (Read-Only). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">sink</td><td>The audio data sink specification (Read-Only). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">requireEqualizer</td><td>set to true if equalizer support is required. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A unique pointer to an <code><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a></code> object if succeeds; otherwise return <code>nullptr</code>. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/ApplicationUtilities/AndroidUtilities/include/AndroidUtilities/<a class="el" href="_android_s_l_e_s_engine_8h_source.html">AndroidSLESEngine.h</a></li>
<li>/workplace/avs-device-sdk/ApplicationUtilities/AndroidUtilities/src/<a class="el" href="_android_s_l_e_s_engine_8cpp.html">AndroidSLESEngine.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
